

import java.io.File;
import java.nio.file.Files;
import java.nio.file.Paths;
import org.vertx.java.core.AsyncResult;
import org.vertx.java.core.AsyncResultHandler;
import org.vertx.java.core.Handler;
import org.vertx.java.core.SimpleHandler;
import org.vertx.java.core.file.AsyncFile;
import org.vertx.java.core.http.HttpClientRequest;
import org.vertx.java.core.http.HttpClientResponse;
import org.vertx.java.core.streams.Pump;
import org.vertx.java.deploy.Verticle;

public class UploadClient extends Verticle {

   private static final boolean CHUNKED = true;
   private static final String FILE = "/home/max/Downloads/FILES/my.mp4";
     private static final int SERVER_PORT = 8080;

   
   @Override
   public void start() throws Exception {
      System.out.println("Started Client connecting to port " + SERVER_PORT);
      final HttpClientRequest req = vertx.createHttpClient().setPort(SERVER_PORT).setHost("localhost").
              put("/bucket1/file6"+Math.random(), new Handler<HttpClientResponse>() {
         @Override
         public void handle(HttpClientResponse response) {
            System.out.println("Got response with code: " + response.statusCode);
         }
      });
      // For a non-chunked upload you need to specify size of upload up-front,
      //else just set chunked to true
      if (!CHUNKED) {
         req.headers().put("Content-Length", Files.size(Paths.get(new File(FILE).toURI())));
      } else {
         req.setChunked(true);
      }

      vertx.fileSystem().open(FILE, new AsyncResultHandler<AsyncFile>() {
         @Override
         public void handle(AsyncResult<AsyncFile> ar) {
            final AsyncFile asyncFile = ar.result;
            Pump pump = Pump.createPump(asyncFile.getReadStream(), req);
            pump.start();

            asyncFile.getReadStream().endHandler(new SimpleHandler() {
               @Override
               public void handle() {
                  asyncFile.close(new AsyncResultHandler<Void>() {
                     @Override
                     public void handle(AsyncResult<Void> ar) {
                        if (ar.exception == null) {
                           req.end();
                           System.out.println("Closing file stream");
                        } else {
                           ar.exception.printStackTrace(System.err);
                        }
                     }
                  });
               }
            });
         }
      });
   }
}
